package com.yonge.cooleshow.biz.dal.dao;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.yonge.cooleshow.biz.dal.dto.search.VideoGroupSearch;
import com.yonge.cooleshow.biz.dal.dto.search.VideoLessonGroupSearch;
import com.yonge.cooleshow.biz.dal.dto.search.VideoLessonSearch;
import com.yonge.cooleshow.biz.dal.entity.VideoLessonGroup;
import com.yonge.cooleshow.biz.dal.entity.VideoLessonGroupLog;
import com.yonge.cooleshow.biz.dal.vo.CountVideoGroupVo;
import com.yonge.cooleshow.biz.dal.vo.LessonGroupVo;
import com.yonge.cooleshow.biz.dal.vo.VideoLessonAuthGroup;
import com.yonge.cooleshow.biz.dal.vo.VideoLessonExamineVo;
import com.yonge.cooleshow.biz.dal.vo.VideoLessonGroupUpVo;
import com.yonge.cooleshow.biz.dal.vo.VideoLessonGroupVo;
import com.yonge.cooleshow.biz.dal.vo.VideoLessonPurchaseVo;
import com.yonge.cooleshow.biz.dal.vo.VideoLessonShelvesVo;
import com.yonge.cooleshow.biz.dal.vo.VideoLessonStudentDetailVo;
import com.yonge.cooleshow.biz.dal.vo.VideoLessonTeacherVo;

/**
 * VideoLessonGroupDao数据库访问类
 *
 * @author yzp
 * @version v1.0
 * @date 2022-03-25 23:46:28
 **/
public interface VideoLessonGroupDao extends BaseMapper<VideoLessonGroup> {
    //查询视频课组
    List<VideoLessonGroupVo> selectPage(IPage page, @Param("param") VideoLessonGroupSearch query);

    //修改视频课组
    void updateGroup(VideoLessonGroupUpVo lessonGroupUpVo);

    void updateExamine(VideoLessonExamineVo examineVo);

    void updateShelves(VideoLessonShelvesVo shelvesVo);

    //学员详情-查询视频课列表
    List<VideoLessonStudentDetailVo> selectStudentPage(IPage page, @Param("param") VideoLessonSearch videoLessonSearch);

    //老师详情-查询视频课列表
    List<VideoLessonTeacherVo> selectTeacherPage(IPage page, @Param("param") VideoLessonSearch videoLessonSearch);

    //老师详情-视频课详情-查询购买学员列表
    List<VideoLessonPurchaseVo> selectPurchaseStudent(IPage page, @Param("param") VideoLessonSearch search);

    //查询视频课组
    List<LessonGroupVo> selectLessonGroup(IPage page, @Param("param") VideoLessonGroupSearch search);
    
  //查询我的视频课组
    List<LessonGroupVo> queryMyLessonGroup(IPage page, @Param("param") VideoLessonGroupSearch search);

    //查询所有视频课组
    List<VideoLessonAuthGroup> queryGroupList(IPage<VideoLessonAuthGroup> page, @Param("param") VideoGroupSearch query);

    List<VideoLessonAuthGroup> queryGroupHistoryList(IPage<VideoLessonAuthGroup> page, @Param("param") VideoGroupSearch query);

    VideoLessonAuthGroup authGroupDetil(@Param("videoGroupId") Long videoGroupId);

    //根据组id查详情
    VideoLessonGroup selectGroupById(Long groupId);

    //统计课时数
    CountVideoGroupVo countVideoGroup();

    //查询付费人数前5的课程
    List<CountVideoGroupVo.VideoLesson> selectVideoLesson();

}